SystemOrganization addCategory: #'Seaside-Gettext-Slime-Tests'!
SystemOrganization addCategory: #'Seaside-Gettext-Slime'!

TestCase subclass: #SeasideGettextSlimeTests
	instanceVariableNames: 'environment model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime-Tests'!

SeasideGettextSlimeTests subclass: #SeasideGettextSlimeAdditionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime-Tests'!

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 10:41'!
compileMethodsUsing: aMethodSelector in: class
	self compile: (self renderMethodOne: aMethodSelector) in: class.
	self compile: (self renderMethodTwo: aMethodSelector) in: class.
	self compile: (self renderMethodThree: aMethodSelector) in: class! !

!SeasideGettextSlimeAdditionTests methodsFor: 'convenience' stamp: 'PaulDeBruicker 12/12/2012 23:59'!
interestingCanvasSelectors
	^WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors selectorsOfInterest ! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/12/2012 23:01'!
removeMethodsNamedAfter: aMethodSelector in: class
	class removeMethod: ('render' , aMethodSelector allButLast capitalized , 'Hi:') asSymbol.
	class removeMethod:('render' , aMethodSelector allButLast capitalized , 'HeyYou:') asSymbol.
	class removeMethod: ('render' , aMethodSelector allButLast capitalized , 'HeyYouTwo:') asSymbol! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/12/2012 22:22'!
renderMethodOne: aMethodSelector
	^ 'render' , aMethodSelector allButLast capitalized , 'Hi:html html ' , aMethodSelector , ' ''hi'''! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/12/2012 22:23'!
renderMethodThree: aMethodSelector
	^ 'render' , aMethodSelector allButLast capitalized , 'HeyYouTwo:html html ' , aMethodSelector , ' ''hey'', self you'! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/12/2012 22:23'!
renderMethodTwo: aMethodSelector
	^ 'render' , aMethodSelector allButLast capitalized , 'HeyYou:html html ' , aMethodSelector , ' ''hey'', ''you'''! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/23/2012 18:07'!
rules
	^ OrderedCollection new
		addAll: WAGettextSlimeTransformationRule allSubclasses;
		yourself! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 17:01'!
testAddSeasideLazyTranslatedToStrings
	| class aMethodSelector result randomSelectors |
	class := self mockObject.
	result := OrderedCollection new.
	result add: 'you ^''you'' seasideLazyTranslated'.
	result add: 'youYou ^''you'' seasideLazyTranslated , ''you'' seasideLazyTranslated'.
	result add: 'youOneYou ^''you'' seasideLazyTranslated , 1 greaseString , ''you'' seasideLazyTranslated'.
	result
		add:
			'youFromStream ^ String streamContents: [:s | s nextPutAll: ''You'' seasideLazyTranslated ; nextPut: $a; nextPutAll: ''fromStream'' seasideLazyTranslated]'.
	self compile: 'you ^ ''you''' in: class.
	self compile: 'youYou ^ ''you'' , ''you''' in: class.
	self compile: 'youOneYou ^ ''you'' , 1 greaseString , ''you''' in: class.
	self
		compile:
			'youFromStream ^ String streamContents: [:s | s nextPutAll: ''You''; nextPut: $a; nextPutAll: ''fromStream'']'
		in: class.
	self runTransformation: WAAddSeasideLazyTranslatedToStrings changes: result! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:45'!
testAddSeasideTranslatedToCanvasMethods
	| class aMethodSelector result randomSelectors |
	class := self mockComponent.
	randomSelectors := OrderedCollection new.
	3 timesRepeat: [ randomSelectors add: self interestingCanvasSelectors atRandom ].
	randomSelectors
		do: [ :each | 
			aMethodSelector := each asString.
			result := OrderedCollection new.
			result add: (self renderMethodOne: aMethodSelector) , ' seasideTranslated.'.
			result
				add:
					'render' , aMethodSelector allButLast capitalized , 'HeyYou:html html ' , aMethodSelector
						, ' ''hey'' seasideTranslated , ''you'' seasideTranslated'.
			result
				add:
					'render' , aMethodSelector allButLast capitalized , 'HeyYouTwo:html html ' , aMethodSelector
						, ' ''hey'' seasideTranslated , self you'.
			self compileMethodsUsing: aMethodSelector in: class.
			self runTransformation: WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors changes: result.
			self removeMethodsNamedAfter: aMethodSelector in: class ]! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:45'!
testAddSeasideTranslatedToNestedCanvasMethods
	| class aMethodSelector result randomSelectors |
	class := self mockComponent.
	result := OrderedCollection new.
	result add: 'renderContentOn: html html listItem:[ html label class:''1234''; with:''acbd'' seasideTranslated]'.
	self compile: 'renderContentOn: html html listItem:[ html label class:''1234''; with:''acbd'']' in: class.
	self runTransformation: WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors changes: result! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:45'!
testAddSeasideTranslatedToStrings
	| class aMethodSelector result randomSelectors |
	class := self mockComponent.
	result := OrderedCollection new.
	result add: 'you ^''you'' seasideTranslated'.
	result add: 'youYou ^''you'' seasideTranslated , ''you'' seasideTranslated'.
	result add: 'youOneYou ^''you'' seasideTranslated , 1 greaseString , ''you'' seasideTranslated'.
	result
		add:
			'youFromStream ^ String streamContents: [:s | s nextPutAll: ''You'' seasideTranslated ; nextPut: $a; nextPutAll: ''fromStream'' seasideTranslated]'.
	self compile: 'you ^ ''you''' in: class.
	self compile: 'youYou ^ ''you'' , ''you''' in: class.
	self compile: 'youOneYou ^ ''you'' , 1 greaseString , ''you''' in: class.
	self
		compile:
			'youFromStream ^ String streamContents: [:s | s nextPutAll: ''You''; nextPut: $a; nextPutAll: ''fromStream'']'
		in: class.
	self runTransformation: WAAddSeasideTranslatedToStrings changes: result! !

!SeasideGettextSlimeAdditionTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:45'!
testRenderToTranslate
	| class renderMethod result |
	class := self mockComponent.
	renderMethod := 'render:'.
	result := 'render' , renderMethod allButLast capitalized , 'Hi:html html translate:''hi''.'.
	self compileMethodsUsing: renderMethod in: class.
	self runTransformation: WAReplaceLiteralStringRenderMethodsWithTranslate changes: {result}! !

SeasideGettextSlimeTests subclass: #SeasideGettextSlimeRemovalTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime-Tests'!

!SeasideGettextSlimeRemovalTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:32'!
rules
	^ OrderedCollection new
		add: WARemoveTranslatedSends;
		yourself! !

!SeasideGettextSlimeRemovalTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:46'!
testRemoveTranslatedSends
	| class aMethodSelector result randomSelectors |
	class := self mockComponent.
	result := OrderedCollection new.
	result add: 'you ^''you'''.
	result add: 'youYou ^''you'' , ''you'''.
	result add: 'youOneYou ^''you'' , 1 greaseString , ''you'''.
	result
		add: 'youFromStream ^ String streamContents: [:s | s nextPutAll: ''You'' ; nextPut: $a; nextPutAll: ''fromStream'']'.
	self compile: 'you ^ ''you'' translated' in: class.
	self compile: 'youYou ^ ''you'' translated , ''you'' translated' in: class.
	self compile: 'youOneYou ^ ''you'' translated, 1 greaseString , ''you'' translated' in: class.
	self
		compile:
			'youFromStream ^ String streamContents: [:s | s nextPutAll: ''You'' translated; nextPut: $a; nextPutAll: ''fromStream'' translated]'
		in: class.
	self runTransformation: WARemoveTranslatedSends changes: result! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:35'!
category
	^ self class category , '-Data'! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:35'!
compile: aString in: aClass
	^ aClass compile: aString classified: #(#rendering)! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:34'!
defineClass: aClassSymbol superclass: aSuperSymbol
	| class |
	model
		defineClass:
			aSuperSymbol , ' subclass: #' , aClassSymbol
				,
					'
		instanceVariableNames: '''' 
		classVariableNames: ''''
		poolDictionaries: ''''
		category: ''' , self category , ''''.
	class := model classNamed: aClassSymbol.
	environment
		addClass: class;
		addClass: class theMetaClass.
	^ class! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:46'!
mockComponent
	^ self defineClass: #WAGettextMockComponent superclass: #WAComponent! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:46'!
mockObject
	^ self defineClass: #WAGettextMockObject superclass: #Object! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:34'!
run: aClass do: aBlock
	| rules rule composite undo |
	rules := self rules collect: [ :each | each new ].
	rule := rules detect: [ :each | each isKindOf: aClass ] ifNone: [ self error: aClass name , ' is not a slime rule' ].
	self assert: (rule name isString and: [ rule name notEmpty ]) description: aClass name , ' has no name'.
	self
		assert: (rule rationale isString and: [ rule rationale notEmpty and: [ rule rationale endsWithSubCollection: '.' ] ])
		description: aClass name , ' has no rationale'.
	composite := RBCompositeLintRule rules: rules name: 'Slime'.
	undo := model changes execute.
	[ 
	RBSmalllintChecker runRule: composite onEnvironment: environment.
	rules
		do: [ :each | 
			self
				assert: (rule = each or: [ each result isEmpty or: [ each changes isEmpty ] ])
				description: each name , ' should not report errors' ].
	aBlock value: rule value: rules ]
		ensure: [ undo execute ].
	^ rule! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:34'!
runTransformation: aClass changes: aCollection
	| expected |
	expected := aCollection collect: [ :each | RBParser parseMethod: each ].
	self
		run: aClass
		do: [ :rule :rules | 
			rule changes
				do: [ :change | 
					self
						assert: (expected anySatisfy: [ :parseTree | change parseTree = parseTree ])
						description: change selector , ' should not be transformed' ].
			expected
				do: [ :parseTree | 
					self
						assert: (rule changes anySatisfy: [ :change | change parseTree = parseTree ])
						description: parseTree selector , ' should be transformed' ] ]! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:34'!
setUp
	super setUp.
	model := RBNamespace new.
	environment := RBClassEnvironment new! !

!SeasideGettextSlimeTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:34'!
tearDown
	super tearDown.
	Smalltalk organization removeCategory: self category! !

GRSlimeTransformationRule subclass: #WAGettextSlimeTransformationRule
	instanceVariableNames: 'checkForMethodNameFragments'
	classVariableNames: 'CanvasSelectorsOfInterest CanvasSelectorsToIgnore'
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime'!

WAGettextSlimeTransformationRule subclass: #WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime'!

!WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 11:51'!
initialize
	super initialize.
	self rewriteRule
		replace: '`@object '
		with: '`@object seasideTranslated'
		when: [ :node | (self nodeIsInterestingString: node) and: [ self parentsDoIncludeSelectorOfInterestFor: node ] ]! !

!WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 00:02'!
name
	^ 'Add seasideTranslated to methods with WAHtmlCanvas selectors'! !

!WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors methodsFor: 'testing' stamp: 'PaulDeBruicker 12/13/2012 18:26'!
nodeIsInterestingString: node
	^ node value isString and: [ node value isSymbol not and: [ node value notEmpty ] ]! !

!WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 16:13'!
parentsDoIncludeSelectorOfInterestFor: node
	node parents reverse
		do: [ :each | 
			each isPragma
				ifTrue: [ ^ false ].
			each isMessage
				ifTrue: [ 
					(self selectorsToIgnore includes: each selector)
						ifTrue: [ ^ false ]
						ifFalse: [ 
							(self selectorsOfInterest includes: each selector)
								ifTrue: [ ^ self doesNotContainNameFragments: each ] ] ] ].
	^ false! !

!WAAddSeasideTranslatedInMethodsWithHtmlCanvasSelectors methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 10:16'!
rationale
	^ 'strings that are concatenated should have each of their string literal parts translated. This is very slow.'! !

WAGettextSlimeTransformationRule subclass: #WAAddSeasideTranslatedToStrings
	instanceVariableNames: ''
	classVariableNames: 'InterestingSubclasses MethodsToIgnore'
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime'!

WAAddSeasideTranslatedToStrings subclass: #WAAddSeasideLazyTranslatedToStrings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime'!

!WAAddSeasideLazyTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 17:25'!
classIsNotWAPainterSubclass
	^ class name = #WAGettextMockObject
		or: [ class name ~= #WAGettextMockComponent and: [ (InterestingSubclasses includes: class) not ] ]! !

!WAAddSeasideLazyTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:42'!
initializeRewriteRule
	self rewriteRule
		replace: '`@object '
		with: '`@object seasideLazyTranslated'
		when: [ :node | self shouldNodeBeTransformed: node ]! !

!WAAddSeasideLazyTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:49'!
name
	^ 'add seasideLazyTranslated to non rendering objects'! !

!WAAddSeasideLazyTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:51'!
rationale
	^ 'When outside of a request, need to use #seasideLazyTranslated.  This version is coarse, hitting every literal string outside of the WAPainter subclasses.'! !

!WAAddSeasideLazyTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 16:03'!
shouldNodeBeTransformed: node

	^ self classIsNotWAPainterSubclass
		and: [ (self nodeIsInterestingString: node) and: [ 	 self parentsDoNotSendMethodToIgnore: node ] ]! !

!WAAddSeasideTranslatedToStrings classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:18'!
initialize
	"self initialize"

	self initializeCanvasSelectors.
	MethodsToIgnore := CanvasSelectorsOfInterest , CanvasSelectorsToIgnore.
	MethodsToIgnore remove: #nextPutAll:.
	InterestingSubclasses := WAPainter allSubclasses asSet! !

!WAAddSeasideTranslatedToStrings classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 08:54'!
methodsToIgnore
	^ MethodsToIgnore! !

!WAAddSeasideTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 17:22'!
classIsWAPainterSubclass
	^ (class name = #WAGettextMockComponent and: [ class name ~= #WAGettextMockObject ])
		or: [ InterestingSubclasses includes: class ]! !

!WAAddSeasideTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:42'!
initialize
	super initialize.
	self initializeRewriteRule! !

!WAAddSeasideTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:42'!
initializeRewriteRule
	self rewriteRule
		replace: '`@object '
		with: '`@object seasideTranslated'
		when: [ :node | self shouldNodeBeTransformed: node ]! !

!WAAddSeasideTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 08:54'!
methodsToIgnore
	^ self class methodsToIgnore! !

!WAAddSeasideTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 00:01'!
name
	^ 'Add seasideTranslated to every string'! !

!WAAddSeasideTranslatedToStrings methodsFor: 'testing' stamp: 'PaulDeBruicker 12/13/2012 18:26'!
nodeIsInterestingString: node
	^ node value isString
		and: [ node value isSymbol not and: [ node value size > 1 and: [ self stringDoesNotIncludeSpeciaCharacters: node value ] ] ]! !

!WAAddSeasideTranslatedToStrings methodsFor: 'testing' stamp: 'PaulDeBruicker 12/14/2012 16:35'!
parentsDoNotSendMethodToIgnore: node

	node parents reverse
		do: [ :each | 
			(each isPragma or:[each isLiteralArray ])
				ifTrue: [ ^ false ].
			each isMessage
				ifTrue: [ 
					(self methodsToIgnore includes: each selector)
						ifTrue: [ ^ false ]
						ifFalse: [ 
							(self doesNotContainNameFragments: each)
								ifFalse: [ ^ false ] ] ]
				ifFalse: [ 
					each isMethod
						ifTrue: [ 
							(self doesNotContainNameFragments: each)
								ifFalse: [ ^ false ] ] ] ].
	^ true! !

!WAAddSeasideTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 08:38'!
rationale
	^ 'This one is probably bad news as it will hit CSS and JS strings. Strings that are concatenated will have each of their string literal parts dumped into a translation file.'! !

!WAAddSeasideTranslatedToStrings methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:39'!
shouldNodeBeTransformed: node
	^ self classIsWAPainterSubclass
		and: [ (self nodeIsInterestingString: node) and: [ self parentsDoNotSendMethodToIgnore: node ] ]! !

!WAAddSeasideTranslatedToStrings methodsFor: 'testing' stamp: 'PaulDeBruicker 12/13/2012 11:58'!
stringDoesNotIncludeSpeciaCharacters: aString
	#($@)
		do: [ :eachCharacter | 
			(aString includes: eachCharacter)
				ifTrue: [ ^ false ] ].
	^ true! !

!WAGettextSlimeTransformationRule classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 08:46'!
initialize
	"self initialize"

	self initializeCanvasSelectors! !

!WAGettextSlimeTransformationRule classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/15/2012 09:18'!
initializeCanvasSelectors
	| jsSelectors |
	CanvasSelectorsOfInterest := (WAHtmlCanvas selectors select: [ :each | each isKeyword ]) asSet.
	CanvasSelectorsOfInterest remove: #heading:level:.
	CanvasSelectorsToIgnore := Set new.
	#(#render: #class: #id: #style: #attributeAt:put: #level: #heading:level: #translate: #on: #for: #handleRequest: #lint: #rationale: #at: #at:put: #resourceUrl: #url: #updateRoot: #updateUrl: #seasideTranslated #seasideLazyTranslated)
		do: [ :each | CanvasSelectorsToIgnore add: each ].
	jsSelectors := ((JSObject withAllSubclasses gather: [ :each | each selectors ]) select: [ :each | each isKeyword ])
		asSet.
	jsSelectors do: [ :each | CanvasSelectorsToIgnore add: each ].
	#(#with: #title: #text: #alert: #confirm: #label: #header:)
		do: [ :each | 
			CanvasSelectorsOfInterest add: each.
			CanvasSelectorsToIgnore remove: each ifAbsent: [ nil ] ]! !

!WAGettextSlimeTransformationRule classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 11:47'!
isVisible
	^ self name ~= #WAGettextSlimeTransformationRule! !

!WAGettextSlimeTransformationRule classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 08:45'!
selectorsOfInterest
	^ CanvasSelectorsOfInterest! !

!WAGettextSlimeTransformationRule classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 08:45'!
selectorsToIgnore
	^ CanvasSelectorsToIgnore! !

!WAGettextSlimeTransformationRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 09:39'!
doesNotContainNameFragments: aNode
	^ checkForMethodNameFragments
		ifTrue: [ self methodNameFragmentsToIgnore allSatisfy: [ :eachRegex | (aNode selector asString matchesRegex: eachRegex) not  ]]
		ifFalse: [ true ]! !

!WAGettextSlimeTransformationRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/23/2012 18:06'!
group
	^ 'Gettext'! !

!WAGettextSlimeTransformationRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 09:34'!
initialize
	super initialize.
	checkForMethodNameFragments := true! !

!WAGettextSlimeTransformationRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/15/2012 09:18'!
methodNameFragmentsToIgnore
	"if you use things like tableClass: or divId as messages for CSS or JS or whatever add some regexes here to check for them'"

	^ #('\w+Id\:?' '\w+Class\:?' '\w+Span\:?' '\w+Width\:?' '\w+Offset\:?' '\w+Fragment\:?' 'test\w+\:?' 'log\w+\:?' 'fuel\w+\:?' 'tropo\w+\:?' 'stripe\w+\:?' '\w+[cC][sS][sS]\w+' '\w+[jJ][sS]\w+' '\w+[Uu]rl\w+\:?')! !

!WAGettextSlimeTransformationRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 08:44'!
selectorsOfInterest
	^ self class selectorsOfInterest! !

!WAGettextSlimeTransformationRule methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 08:44'!
selectorsToIgnore
	^self class selectorsToIgnore ! !

WAGettextSlimeTransformationRule subclass: #WAReformLiteralArraysIntoArraysWithWithWithWithEtc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime'!

!WAReformLiteralArraysIntoArraysWithWithWithWithEtc methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 17:12'!
initialize
	super initialize.
	self rewriteRule
		replace: '`@object '
		withValueFrom: [ :node | self newArrayOfLiteralsSourceFor: node ]
		when: [ :node | self isLiteralStringArrayOfSize6OrLess: node ]! !

!WAReformLiteralArraysIntoArraysWithWithWithWithEtc methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 17:09'!
isLiteralStringArrayOfSize6OrLess: node
	^ node isLiteralArray
		and: [ 
			node contents notEmpty
				and: [ node contents size <= 6 and: [ node contents allSatisfy: [ :each | each isString and: [ each isSymbol not ] ] ] ] ]! !

!WAReformLiteralArraysIntoArraysWithWithWithWithEtc methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 16:24'!
name
	^ 'Attempt to replace the literal arrays'! !

!WAReformLiteralArraysIntoArraysWithWithWithWithEtc methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 16:57'!
newArrayOfLiteralsSourceFor: node
	| string message |
	string := String
		streamContents: [ :s | 
			s nextPutAll: 'Array '.
			node contents do: [ :eachLiteralNode | s nextPutAll: 'with: ''' , eachLiteralNode value , ''' ' ] ].
	message := RBParser parseExpression: string.
	^ message! !

!WAReformLiteralArraysIntoArraysWithWithWithWithEtc methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/14/2012 16:23'!
rationale
	^ 'We are adding #seasideTranslated to everything which really does not work out very well with the #("adsf" "asdf") way of making arrays.'! !

WAGettextSlimeTransformationRule subclass: #WARemoveTranslatedSends
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime'!

!WARemoveTranslatedSends methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:27'!
initialize
	super initialize.
	self rewriteRule replace: '`@object translated' with: '`@object '! !

!WARemoveTranslatedSends methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:26'!
name
	^ 'Remove existing sends of #translated'! !

!WARemoveTranslatedSends methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 16:29'!
rationale
	^ 'We are adding #seasideTranslated to everything so the #translated sends are redundant.'! !

WAGettextSlimeTransformationRule subclass: #WAReplaceLiteralStringRenderMethodsWithTranslate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Gettext-Slime'!

!WAReplaceLiteralStringRenderMethodsWithTranslate methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 12/13/2012 18:27'!
initialize
	super initialize.
	self rewriteRule
		replace: '`@object render: ``@args'
		with: '`@object translate: ``@args'
		when: [ :node | 
			node arguments
				allSatisfy: [ :each | each isLiteralNode and: [ each token value isString and: [ each token value isSymbol not ] ] ] ]! !

!WAReplaceLiteralStringRenderMethodsWithTranslate methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/23/2012 16:56'!
name
	^ 'Replace #render: with #translate: '! !

!WAReplaceLiteralStringRenderMethodsWithTranslate methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/23/2012 18:08'!
rationale
	^ 'Replace #render:  with #translated: when the only argument is a string.'! !
WAAddSeasideTranslatedToStrings initialize!
WAGettextSlimeTransformationRule initialize!
